import { createElement } from 'react';
import enUS from './en-US.json';
import zhCN from './zh-CN.json';
var instance = {
  'zh-CN': zhCN,
  'en-US': enUS
};
export function createIntl(locale) {
  if (locale === void 0) {
    locale = 'zh-CN';
  }
  var intl = function intl(id) {
    var _instance$locale;
    return ((_instance$locale = instance[locale]) === null || _instance$locale === void 0 ? void 0 : _instance$locale[id]) || id;
  };
  var intlNode = function intlNode(id) {
    var _instance$locale2;
    return /*#__PURE__*/createElement('span', ((_instance$locale2 = instance[locale]) === null || _instance$locale2 === void 0 ? void 0 : _instance$locale2[id]) || id);
  };
  return {
    intl: intl,
    intlNode: intlNode
  };
}