import { findDOMNode } from 'react-dom';
import { isElement } from '@alilc/lowcode-utils';
import { isDOMNode } from './is-dom-node';
export var getReactInternalFiber = function getReactInternalFiber(el) {
  return el._reactInternals || el._reactInternalFiber;
};
function elementsFromFiber(fiber, elements) {
  if (fiber) {
    if (fiber.stateNode && isDOMNode(fiber.stateNode)) {
      elements.push(fiber.stateNode);
    } else if (fiber.child) {
      // deep fiberNode.child
      elementsFromFiber(fiber.child, elements);
    }
    if (fiber.sibling) {
      elementsFromFiber(fiber.sibling, elements);
    }
  }
}
export function reactFindDOMNodes(elem) {
  if (!elem) {
    return null;
  }
  if (isElement(elem)) {
    return [elem];
  }
  var elements = [];
  var fiberNode = getReactInternalFiber(elem);
  elementsFromFiber(fiberNode === null || fiberNode === void 0 ? void 0 : fiberNode.child, elements);
  if (elements.length > 0) return elements;
  try {
    return [findDOMNode(elem)];
  } catch (e) {
    return null;
  }
}