"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.createIntl = createIntl;
var _react = require("react");
var _enUS = _interopRequireDefault(require("./en-US.json"));
var _zhCN = _interopRequireDefault(require("./zh-CN.json"));
var instance = {
  'zh-CN': _zhCN["default"],
  'en-US': _enUS["default"]
};
function createIntl(locale) {
  if (locale === void 0) {
    locale = 'zh-CN';
  }
  var intl = function intl(id) {
    var _instance$locale;
    return ((_instance$locale = instance[locale]) === null || _instance$locale === void 0 ? void 0 : _instance$locale[id]) || id;
  };
  var intlNode = function intlNode(id) {
    var _instance$locale2;
    return /*#__PURE__*/(0, _react.createElement)('span', ((_instance$locale2 = instance[locale]) === null || _instance$locale2 === void 0 ? void 0 : _instance$locale2[id]) || id);
  };
  return {
    intl: intl,
    intlNode: intlNode
  };
}