"use strict";

exports.__esModule = true;
exports.getReactInternalFiber = void 0;
exports.reactFindDOMNodes = reactFindDOMNodes;
var _reactDom = require("react-dom");
var _lowcodeUtils = require("@alilc/lowcode-utils");
var _isDomNode = require("./is-dom-node");
var getReactInternalFiber = exports.getReactInternalFiber = function getReactInternalFiber(el) {
  return el._reactInternals || el._reactInternalFiber;
};
function elementsFromFiber(fiber, elements) {
  if (fiber) {
    if (fiber.stateNode && (0, _isDomNode.isDOMNode)(fiber.stateNode)) {
      elements.push(fiber.stateNode);
    } else if (fiber.child) {
      // deep fiberNode.child
      elementsFromFiber(fiber.child, elements);
    }
    if (fiber.sibling) {
      elementsFromFiber(fiber.sibling, elements);
    }
  }
}
function reactFindDOMNodes(elem) {
  if (!elem) {
    return null;
  }
  if ((0, _lowcodeUtils.isElement)(elem)) {
    return [elem];
  }
  var elements = [];
  var fiberNode = getReactInternalFiber(elem);
  elementsFromFiber(fiberNode === null || fiberNode === void 0 ? void 0 : fiberNode.child, elements);
  if (elements.length > 0) return elements;
  try {
    return [(0, _reactDom.findDOMNode)(elem)];
  } catch (e) {
    return null;
  }
}